module external_memory_32
(
  input  clk,
  input  reset,
  output signed [32-1 : 0] data_length,
  input signed [32-1 : 0] data_address,
  input signed [32-1 : 0] data_din,
  output signed [32-1 : 0] data_dout,
  input  data_we,
  input  data_oe,
  input signed [32-1 : 0] ext_length,
  output signed [32-1 : 0] ext_address,
  output signed [32-1 : 0] ext_din,
  input signed [32-1 : 0] ext_dout,
  output  ext_we,
  output  ext_oe
);

  wire  clk_sig;
  wire  reset_sig;
  wire signed [32-1 : 0] data_length_sig;
  wire signed [32-1 : 0] data_address_sig;
  wire signed [32-1 : 0] data_din_sig;
  wire signed [32-1 : 0] data_dout_sig;
  wire  data_we_sig;
  wire  data_oe_sig;
  wire signed [32-1 : 0] ext_length_sig;
  wire signed [32-1 : 0] ext_address_sig;
  wire signed [32-1 : 0] ext_din_sig;
  wire signed [32-1 : 0] ext_dout_sig;
  wire  ext_we_sig;
  wire  ext_oe_sig;



  assign clk_sig = clk;
  assign reset_sig = reset;
  assign data_length = data_length_sig;
  assign data_length_sig = ext_length_sig;

  assign data_address_sig = data_address;
  assign data_din_sig = data_din;
  assign data_dout = data_dout_sig;
  assign data_dout_sig = ext_dout_sig;

  assign data_we_sig = data_we;
  assign data_oe_sig = data_oe;
  assign ext_length_sig = ext_length;
  assign ext_address = ext_address_sig;
  assign ext_address_sig = data_address_sig;

  assign ext_din = ext_din_sig;
  assign ext_din_sig = data_din_sig;

  assign ext_dout_sig = ext_dout;
  assign ext_we = ext_we_sig;
  assign ext_we_sig = data_we_sig;

  assign ext_oe = ext_oe_sig;
  assign ext_oe_sig = data_oe_sig;






endmodule
